'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @license
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright Opensoft. All Rights Reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Use of this source code is governed by an Apache 2 license that can be
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * found in the LICENSE file at https://bitbucket.org/opensoftgitrepo/lightweightform/src/develop/LICENSE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _handlebars = require('handlebars');

var _handlebars2 = _interopRequireDefault(_handlebars);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TemplateManager = function () {
  function TemplateManager() {
    _classCallCheck(this, TemplateManager);
  }

  _createClass(TemplateManager, null, [{
    key: 'compileHandleBar',
    value: function compileHandleBar(path, context) {
      return _handlebars2.default.compile(_fs2.default.readFileSync(path).toString())(context);
    }
  }]);

  return TemplateManager;
}();

module.exports = {
  // Maven
  loadPomParent: function loadPomParent(context) {
    return TemplateManager.compileHandleBar('src/main/templates/maven/pom-parent.handlebars', context);
  },
  loadCommonPom: function loadCommonPom(context) {
    return TemplateManager.compileHandleBar('src/main/templates/maven/pom-common.handlebars', context);
  },
  loadCommonJsPom: function loadCommonJsPom(context) {
    return TemplateManager.compileHandleBar('src/main/templates/maven/pom-common-js.handlebars', context);
  },
  loadCommonJvmPom: function loadCommonJvmPom(context) {
    return TemplateManager.compileHandleBar('src/main/templates/maven/pom-common-jvm.handlebars', context);
  },
  // NPM
  loadCommonJsNpm: function loadCommonJsNpm(context) {
    return TemplateManager.compileHandleBar('src/main/templates/npm/common-js-package-json.handlebars', context);
  },
  // Schema
  loadRecordSchema: function loadRecordSchema(context) {
    return TemplateManager.compileHandleBar('src/main/templates/schema/record.schema.handlebars', context);
  },
  // Storage
  loadRecordStorage: function loadRecordStorage(context) {
    return TemplateManager.compileHandleBar('src/main/templates/storage/record.storage.handlebars', context);
  },
  // Validator
  loadValidationMessages: function loadValidationMessages(context) {
    return TemplateManager.compileHandleBar('src/main/templates/validator/validation.messages.handlebars', context);
  },
  // README
  loadReadme: function loadReadme(context) {
    return TemplateManager.compileHandleBar('src/main/templates/readme-' + (context.template || 'common') + '-md.handlebars', context);
  }
};